> ## Documentation Index
> Fetch the complete documentation index at: https://openwearables.io/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Sign Multipart Parts

> Presign upload URLs for a batch of parts of an in-progress multipart upload.



## OpenAPI

````yaml https://api.openwearables.io/openapi.json post /api/v1/users/{user_id}/import/apple/xml/s3/multipart/sign
openapi: 3.1.0
info:
  title: Open Wearables API
  version: 0.1.0
servers: []
security: []
paths:
  /api/v1/users/{user_id}/import/apple/xml/s3/multipart/sign:
    post:
      tags:
        - 'External: Apple Health Import'
      summary: Sign Multipart Parts
      description: >-
        Presign upload URLs for a batch of parts of an in-progress multipart
        upload.
      operationId: >-
        sign_multipart_parts_api_v1_users__user_id__import_apple_xml_s3_multipart_sign_post
      parameters:
        - name: user_id
          in: path
          required: true
          schema:
            type: string
            title: User Id
        - name: X-Open-Wearables-API-Key
          in: header
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            title: X-Open-Wearables-Api-Key
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MultipartSignRequest'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MultipartSignResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - OAuth2PasswordBearer: []
components:
  schemas:
    MultipartSignRequest:
      properties:
        key:
          type: string
          maxLength: 1024
          title: Key
          description: Object key returned by create
        upload_id:
          type: string
          maxLength: 1024
          title: Upload Id
          description: Upload id returned by create
        part_numbers:
          items:
            type: integer
            maximum: 10000
            minimum: 1
          type: array
          maxItems: 10000
          minItems: 1
          title: Part Numbers
          description: Part numbers (1-based) to presign upload URLs for
        expiration_seconds:
          type: integer
          maximum: 86400
          minimum: 60
          title: Expiration Seconds
          description: Presigned URL lifetime in seconds
          default: 86400
      type: object
      required:
        - key
        - upload_id
        - part_numbers
      title: MultipartSignRequest
    MultipartSignResponse:
      properties:
        urls:
          items:
            $ref: '#/components/schemas/SignedPart'
          type: array
          title: Urls
      type: object
      required:
        - urls
      title: MultipartSignResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    SignedPart:
      properties:
        part_number:
          type: integer
          maximum: 10000
          minimum: 1
          title: Part Number
        url:
          type: string
          title: Url
      type: object
      required:
        - part_number
        - url
      title: SignedPart
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    OAuth2PasswordBearer:
      type: oauth2
      flows:
        password:
          scopes: {}
          tokenUrl: /api/v1/auth/login

````